-----------------------
-- Wired             --
-- By: Wire @ Byriel --
-----------------------

Wired.UI.ColorPicker.Component = class();

function Wired.UI.ColorPicker.Component:Constructor(name, red, green, blue)

  -- apply parameters
  self:SetName(name);
  self:SetRed(red);
  self:SetGreen(green);
  self:SetBlue(blue);
end

-- getters and setters
function Wired.UI.ColorPicker.Component:GetName()
  return self.name;
end

function Wired.UI.ColorPicker.Component:SetName(value)
  self.name = value;
end

function Wired.UI.ColorPicker.Component:GetRed()
  return self.red;
end

function Wired.UI.ColorPicker.Component:SetRed(value)
  self.red = value;
end

function Wired.UI.ColorPicker.Component:GetGreen()
  return self.green;
end

function Wired.UI.ColorPicker.Component:SetGreen(value)
  self.green = value;
end

function Wired.UI.ColorPicker.Component:GetBlue()
  return self.blue;
end

function Wired.UI.ColorPicker.Component:SetBlue(value)
  self.blue = value;
end

-- constants
Wired.UI.ColorPicker.Component.Red = Wired.UI.ColorPicker.Component("Red", 1, 0, 0);
Wired.UI.ColorPicker.Component.Green = Wired.UI.ColorPicker.Component("Green", 0, 1, 0);
Wired.UI.ColorPicker.Component.Blue = Wired.UI.ColorPicker.Component("Blue", 0, 0, 1);

-- components
Wired.UI.ColorPicker.Components = {
  Wired.UI.ColorPicker.Component.Red,
  Wired.UI.ColorPicker.Component.Green,
  Wired.UI.ColorPicker.Component.Blue
};
